package jp.hishidama.swing.drag.window;

import java.awt.*;

/**
 * [Iɔwi𓧉߂锠hbOEBhE.
 * <p>
 * gȊO̔wi[Iɓ߂B<br>
 * ŏɃfXNgbv̑Sʂ擾̂ŁA}Vp[ȂƏdB
 * </p>
 * <p><a target="hishidama"
 * href="http://www.ne.jp/asahi/hishidama/home/tech/soft/java/swing/DragWindow.html">gp</a>
 * </p>
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/tech/soft/java/swing.html">Ђ</a>
 * @since 2007.02.11
 * @version 2007.02.22
 */
public class DragWindow extends Window {

	/**
	 * 
	 */
	private static final long serialVersionUID = -2338068862539204147L;

	/** g̐F */
	protected Color borderColor = Color.BLACK;

	/** EBhE쐬̑Sʂ̉摜 */
	protected Image image;

	/** }EXƃEBhȆ΍WX */
	protected int nx;

	/** }EXƃEBhȆ΍WY */
	protected int ny;

	/**
	 * jre1.6Ŏgp\ȃRXgN^[
	 * 
	 * @param mouse
	 *            ŏ̃}EẌʒu
	 * @param location
	 *            ŏ̃EBhËʒu
	 * @param size
	 *            EBhẼTCY
	 */
	public DragWindow(Point mouse, Point location, Dimension size) {
		this(null, mouse, location, size);
	}

	/**
	 * RXgN^[
	 * 
	 * @param owner
	 *            eEBhE
	 * @param mouse
	 *            ŏ̃}EẌʒu
	 * @param location
	 *            ŏ̃EBhËʒu
	 * @param size
	 *            EBhẼTCY
	 */
	public DragWindow(Window owner, Point mouse, Point location, Dimension size) {
		super(owner);
		setBounds(location.x, location.y, size.width, size.height);
		nx = location.x - mouse.x;
		ny = location.y - mouse.y;
		initImage();
	}

	/**
	 * 摜̏
	 */
	public void initImage() {
		Dimension sz = Toolkit.getDefaultToolkit().getScreenSize();

		Robot robot = null;
		try {
			robot = new Robot();
		} catch (AWTException e) {
			throw new RuntimeException(e);
		}
		Point pt = new Point(0, 0);
		image = robot.createScreenCapture(new Rectangle(pt, sz));
	}

	/**
	 * g̐Fݒ
	 * 
	 * @param c
	 *            g̐F
	 */
	public void setBorderColor(Color c) {
		borderColor = c;
	}

	/**
	 * g̐F擾
	 * 
	 * @return g̐F
	 */
	public Color getBorderColor() {
		return borderColor;
	}

	/**
	 * }EXʒuwł̃EBhEړ.
	 * <p>
	 * EBhE쐬ɕێŏ̃}EXʒuƔrAEBhËʒuړB
	 * </p>
	 */
	public void setMouseLocation(Point mouse) {
		int x = mouse.x + nx;
		int y = mouse.y + ny;
		setLocation(x, y);
	}

	public void setBounds(int x, int y, int width, int height) {
		int oldx = getX();
		int oldy = getY();
		super.setBounds(x, y, width, height);
		if (x != oldx || y != oldy) {
			invalidate();
			repaint();
		}
	}

	/**
	 * `s
	 */
	public void paint(Graphics g) {
		int x = getX();
		int y = getY();
		int w = getWidth();
		int h = getHeight();

		g.drawImage(image, 0, 0, w, h, x, y, x + w, y + h, null);

		g.setColor(getBorderColor());
		g.drawRect(0, 0, w - 1, h - 1);
	}

}
